[regression] GTK and KDE apps fail to start under Unity8 (without gnome-session running)

Bug #1675364 reported by Albert Astals Cid on 2017-03-23
28
This bug affects 6 people
Affects Status Importance Assigned to Milestone
Canonical System Image
Critical
Stephen M. Webb
gtk+3.0 (Ubuntu)
Critical
Unassigned
libertine (Ubuntu)
Undecided
Unassigned
mir (Ubuntu)
Undecided
Unassigned
qtmir (Ubuntu)
Undecided
Unassigned
ubuntu-app-launch (Ubuntu)
Undecided
Unassigned
unity8 (Ubuntu)
Undecided
Unassigned
xorg-server (Ubuntu)
Undecided
Unassigned

Bug Description

Recently something has regressed and if i start konsole (using xmir) in unity8 all i get is the splash screen with a spinner forever.

Looking at the ps output it seems that the konsole process has actually started.

Michał Sawicz (saviq) on 2017-03-23
Changed in canonical-devices-system-image:
status: New → Triaged
importance: Undecided → Critical
milestone: none → u8c-z
assignee: nobody → Stephen M. Webb (bregma)
no longer affects: xorg (Ubuntu)
Changed in unity8 (Ubuntu):
status: New → Incomplete
Changed in qtmir (Ubuntu):
status: New → Incomplete
Stephen M. Webb (bregma) wrote :

Does the problem persist after a reboot?

Stephen M. Webb (bregma) wrote :
Download full text (4.0 KiB)

OK, I can repro this on one machine but not another (not sure what the difference is yet). For the record, journalctl is spammed with error like the following when it does happen.

Mar 23 09:00:01 xt2-17 konsole[12421]: g_application_get_application_id: assertion 'G_IS_APPLICATION (application)' failed
Mar 23 09:00:01 xt2-17 konsole[12421]: g_variant_new_string: assertion 'string != NULL' failed
Mar 23 09:00:01 xt2-17 konsole[12421]: g_application_get_application_id: assertion 'G_IS_APPLICATION (application)' failed
Mar 23 09:00:01 xt2-17 konsole[12421]: g_variant_new_string: assertion 'string != NULL' failed
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-fallback-icon-theme
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-icon-sizes
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-alternative-button-order
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-show-input-method-menu
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-show-unicode-menu
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-timeout-initial
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-timeout-repeat
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-timeout-expand
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-color-scheme
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-touchscreen-mode
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-tooltip-timeout
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-tooltip-browse-timeout
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-tooltip-browse-mode-timeout
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-keynav-cursor-only
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-keynav-wrap-around
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property color-hash
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-file-chooser-backend
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-print-backends
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-print-preview-command
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-recent-files-limit
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-fontconfig-timestamp
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-sound-theme-name
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-enable-input-feedback-sounds
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-enable-event-sounds
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-enable-tooltips
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-toolbar-style
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-toolbar-icon-size
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-auto-mnemonics
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-visible-focus
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-entry-password-hint-timeout
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-menu-bar-popup-delay
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-scrolled-window-placement
Mar 23 09:00:01 xt2-17 konsole[12421]: unknown property gtk-c...

Read more...

Christopher Townsend (townsend) wrote :

Is this on Zesty or X+O?

Stephen M. Webb (bregma) wrote :

More information: the system on which this occurring shows konsole is stuck waiting for a child bash process.

12414 ? Ss 0:00 \_ /usr/bin/python3 /usr/bin/libertine-launch konsole
12415 ? Sl 0:00 | \_ Xmir -rootless -displayfd 3 -mir org.kde.konsole
12420 ? Sl 0:00 | \_ pasted
12421 ? Sl 0:00 | \_ konsole
12450 pts/4 Ss+ 0:00 | \_ /bin/bash

Stephen M. Webb (bregma) wrote :

It seems the difference between my two test machines is that one one I had logged in to Unity 7 previously, and that left gnome-session-binary running. After a reboot to kill all systemd --user units, konsole now hangs on both test machines.

It looks like this problem is in konsole, which requires gnome-session to be running in order to function normally.

Albert Astals Cid (aacid) wrote :

Yes, it persists across reboots (i'd say it started happening around 2 or 3 days ago)

Zesty, for me.

I just used konsole as an example, it seems to me it's all xmir apps, another one i tried and fails is gnome-sudoku.

Stephen M. Webb (bregma) wrote :

I get the same behaviour from gedit. It seems any application relying on gnome-session running is going to hang. I would point at some Gnome library as being the casue of this.

Stephen M. Webb (bregma) on 2017-03-23
summary: - [Regression] xmir applications fail to render
+ [Regression] applications linked to GTK fail to start without gnome-
+ session running
Changed in xorg-server (Ubuntu):
status: New → Invalid
Changed in qtmir (Ubuntu):
status: Incomplete → Invalid
Changed in libertine (Ubuntu):
status: New → Invalid
Changed in mir (Ubuntu):
status: New → Invalid

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in ubuntu-app-launch (Ubuntu):
status: New → Confirmed
William Hua (attente) on 2017-03-23
Changed in gtk+3.0 (Ubuntu):
assignee: nobody → William Hua (attente)
Stephen M. Webb (bregma) on 2017-03-23
Changed in unity8 (Ubuntu):
status: Incomplete → Invalid
Changed in ubuntu-app-launch (Ubuntu):
status: Confirmed → Invalid
Changed in gtk+3.0 (Ubuntu):
status: New → Confirmed
tags: added: gtk-mir unity8-desktop
Daniel van Vugt (vanvugt) wrote :

$ gnome-calculator -- --desktop_file_hint=unity8

(gnome-calculator:5516): Gdk-WARNING **: unknown property gtk-fallback-icon-theme

(gnome-calculator:5516): Gdk-WARNING **: unknown property gtk-icon-sizes

(gnome-calculator:5516): Gdk-WARNING **: unknown property gtk-alternative-button-order

(gnome-calculator:5516): Gdk-WARNING **: unknown property gtk-show-input-method-menu

(gnome-calculator:5516): Gdk-WARNING **: unknown property gtk-show-unicode-menu

(gnome-calculator:5516): Gdk-WARNING **: unknown property gtk-timeout-initial

(gnome-calculator:5516): Gdk-WARNING **: unknown property gtk-timeout-repeat

(gnome-calculator:5516): Gdk-WARNING **: unknown property gtk-timeout-expand

(gnome-calculator:5516): Gdk-WARNING **: unknown property gtk-color-scheme

......

Changed in gtk+3.0 (Ubuntu):
importance: Undecided → Critical
summary: - [Regression] applications linked to GTK fail to start without gnome-
- session running
+ [regression] GTK apps fail to start under Unity8 (without gnome-session
+ running)
Stephen M. Webb (bregma) on 2017-03-24
summary: - [regression] GTK apps fail to start under Unity8 (without gnome-session
- running)
+ [regression] GTK and KDE apps fail to start under Unity8 (without gnome-
+ session running)
dinamic (dinamic6661) wrote :

same here 17.04 when using Xmir, without Xmir the apps seems to start

logs from supertux2 (sdl)

mar 24 12:30:15 pixel-desktop systemd[3611]: Starting ubuntu-app-launch--application-legacy--supertux2--1490351415016768.service...
----
mar 24 12:30:16 pixel-desktop xmir-helper[6363]: Cannot connect to server socket err = No such file or directory
mar 24 12:30:16 pixel-desktop xmir-helper[6363]: Cannot connect to server request channel
mar 24 12:30:16 pixel-desktop xmir-helper[6363]: jack server is not running or cannot be started
mar 24 12:30:16 pixel-desktop xmir-helper[6363]: JackShmReadWritePtr::~JackShmReadWritePtr - Init not done for 4294967295, skipping unlock
mar 24 12:30:45 pixel-desktop xmir-helper[6363]: XIO: fatal IO error 4 (Interrupted system call) on X server ":0"
mar 24 12:30:45 pixel-desktop xmir-helper[6363]: after 932 requests (932 known processed) with 0 events remaining.
mar 24 12:30:45 pixel-desktop xmir-helper[6363]: AL lib: (EE) alc_cleanup: 1 device not closed
mar 24 12:30:45 pixel-desktop systemd[3611]: Stopped ubuntu-app-launch--application-legacy--supertux2--1490351415016768.service.

the app seems to start? i hear the sound but i don't see the game only the spinning loader on a black window

Stephen M. Webb (bregma) wrote :

@dinamic I think you're seeing a different problem with similar symptoms, probably related to libSDL2 probing order.

dinamic (dinamic6661) wrote :

probably, btw.. did something change in the way the apps are launched? so after a reboot i've launched gnome chess from launcher, the app started (without Xmir) and worked great. but then i closed the app and the second time it tried to launch with Xmir but failed to load. (not sure why it tried to launch with Xmir the next times, i also did not changed anything in .desktop file)

dinamic (dinamic6661) wrote :

gnome-chess log. (if i manually launch gnome-chess with Xmir it works fine, same native, it only doesn't work if i launch from the launcher/app drawer)

Mar 24 20:54:07 pixel-desktop gnome-chess[18994]: Ignoring unknown Mir event 11
Mar 24 20:54:07 pixel-desktop gnome-chess[18994]: Ignoring unknown Mir event 8
Mar 24 20:54:07 pixel-desktop xmir-helper[18986]: pasted: Qt: Session management error: Could not open network socket
Mar 24 20:54:42 pixel-desktop xmir-helper[18986]: pasted: The X11 connection broke: I/O error (code 1)
Mar 24 20:54:42 pixel-desktop xmir-helper[18986]: XIO: fatal IO error 11 (Resource temporarily unavailable) on X server ":0"
Mar 24 20:54:42 pixel-desktop xmir-helper[18986]: after 7 requests (6 known processed) with 0 events remaining.
Mar 24 20:54:49 pixel-desktop gnome-chess[18994]: AT-SPI: Could not obtain desktop path or name

dinamic (dinamic6661) wrote :

Mar 25 08:40:55 pixel-desktop gnome-chess[3613]: Ignoring unknown Mir event 8
Mar 25 08:40:56 pixel-desktop xmir-helper[3602]: (EE)
Mar 25 08:40:56 pixel-desktop xmir-helper[3602]: Fatal server error:
Mar 25 08:40:56 pixel-desktop xmir-helper[3602]: (EE) Failed to connect to Mir: Failed to connect: not accepted by server
Mar 25 08:40:56 pixel-desktop xmir-helper[3602]: (EE)
Mar 25 08:40:56 pixel-desktop gnome-chess[3613]: AT-SPI: Could not obtain desktop path or name
Mar 25 08:40:56 pixel-desktop gnome-chess[3613]: atk-bridge: get_device_events_reply: unknown signature
Mar 25 08:40:56 pixel-desktop gnome-chess[3613]: atk-bridge: get_device_events_reply: unknown signature
Mar 25 08:40:56 pixel-desktop gnome-chess[3613]: atk-bridge: GetRegisteredEvents returned message with unknown signature
Mar 25 08:40:56 pixel-desktop gnome-chess[3613]: AT-SPI: Could not obtain desktop path or name
Mar 25 08:40:56 pixel-desktop gnome-chess[3613]: AT-SPI: Could not obtain desktop path or name
Mar 25 08:40:56 pixel-desktop gnome-chess[3613]: AT-SPI: Could not obtain desktop path or name
Mar 25 08:40:56 pixel-desktop xmir-helper[3602]: pasted: QXcbConnection: Could not connect to display :0
Mar 25 08:42:52 pixel-desktop gnome-chess[3613]: Ignoring unknown Mir event 11
Mar 25 08:45:10 pixel-desktop gnome-chess[3613]: AT-SPI: Could not obtain desktop path or name

Ok, I've traced this down to bug #1675448 being the root of the issue. Xmir is started no matter what and if an application natively supports Mir such as a Gtk or Qt app, then there are multiple connections to Mir, which is what the aforementioned bug is about.

So a decision needs to be made. Either bug #1675448 needs to be fixed or we need to revert the Gtk probing order back and just use xmir for the time being.

The longer term solution of only starting xmir when it is actually needed along with Mir supported toolkits probing for Mir first is the final solution (see bug #1672931). But that won't be done in time for the Zesty release, hence the other options presented above:)

William Hua (attente) wrote :

For gtk, instead of changing the probing order, is it possible to set GDK_BACKEND=x11 for the launched app specifically when u-a-l/libertine-launch spawn xmir instead?

Stephen M. Webb (bregma) on 2017-03-30
Changed in gtk+3.0 (Ubuntu):
assignee: William Hua (attente) → nobody
status: Confirmed → Invalid
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers